# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
# Copyright 2022 Linaro Ltd.
%YAML 1.2
---
$id: http://devicetree.org/schemas/usb/faraday,fotg210.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Faraday Technology FOTG200 series HS OTG USB 2.0 controller

maintainers:
  - Linus Walleij <linusw@kernel.org>

allOf:
  - $ref: usb-drd.yaml#
  - $ref: usb-hcd.yaml#

properties:
  compatible:
    oneOf:
      - const: faraday,fotg200
      - const: faraday,fotg210
      - items:
          - const: cortina,gemini-usb
          - const: faraday,fotg200

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  clocks:
    maxItems: 1

  clock-names:
    items:
      - const: PCLK

  resets:
    maxItems: 1

  syscon:
    $ref: /schemas/types.yaml#/definitions/phandle
    description: a phandle to the global Gemini system controller on
      Gemini systems

  dr_mode: true

  phys:
    maxItems: 1

  phy-names:
    const: usb2-phy

required:
  - compatible
  - reg
  - interrupts
  - clocks
  - clock-names

additionalProperties: false

examples:
  - |
    #include <dt-bindings/interrupt-controller/irq.h>
    #include <dt-bindings/clock/cortina,gemini-clock.h>
    #include <dt-bindings/reset/cortina,gemini-reset.h>
    usb0: usb@68000000 {
        compatible = "cortina,gemini-usb", "faraday,fotg200";
        reg = <0x68000000 0x1000>;
        interrupts = <10 IRQ_TYPE_LEVEL_HIGH>;
        resets = <&syscon GEMINI_RESET_USB0>;
        clocks = <&syscon GEMINI_CLK_GATE_USB0>;
        clock-names = "PCLK";
        syscon = <&syscon>;
        dr_mode = "host";
    };
